import { system, world } from '@minecraft/server';

function durabilityOnChanged(item, player, isHitEntity = false) {
    let level = item.getComponent("minecraft:enchantable")?.getEnchantment("unbreaking")?.level;

    function durability() {
        let durability = item.getComponent("minecraft:durability");

        const t = Math.floor(Math.random() * 100);

        if (t < durability.getDamageChance()) {
            if (!isHitEntity) durability.damage += 1;
            if (durability.damage >= durability.maxDurability) {
                player.playSound("random.break");
                if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', undefined)
            } else {
                if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', item)
            }
        } else {
            if (!isHitEntity) return;
            durability.damage -= 1;
            if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', item);
        }
    }

    const t = Math.floor(Math.random() * 10)
    if (level === 1 && t > 8) return;
    else if (level === 2 && t > 6) return;
    else if (level === 3 && t > 4) return;
    else durability();
}

world.beforeEvents.worldInitialize.subscribe(initEvent => { initEvent.itemComponentRegistry.registerCustomComponent('tbc_refri_guarana:trigger', {
  onConsume: e => {
  e.source.addEffect("minecraft:speed", 2000, {amplifier: 2});
  
},

  
});

initEvent.itemComponentRegistry.registerCustomComponent('tmb_figo_dinferno:trigger', {
  onConsume: e => {
  e.source.removeEffect("minecraft:hunger");
  
},

  
});

initEvent.itemComponentRegistry.registerCustomComponent('tbc_suco_camucamu:trigger', {
  onConsume: e => {
  e.source.removeEffect("minecraft:mining_fatigue");
e.source.removeEffect("minecraft:weakness");
e.source.removeEffect("minecraft:slowness");
  
},

  
});

initEvent.itemComponentRegistry.registerCustomComponent('tmb_pacote_tuiuiu_toten1:trigger', {
  onUse: e => { e.source.runCommand("function toten1");
e.source.runCommand("function tirapaco1"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('tmb_pacote_tuiuiu_toten2:trigger', {
  onUse: e => { e.source.runCommand("function toten2");
e.source.runCommand("function tirapaco2"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('tmb_pacote_tuiuiu_toten3:trigger', {
  onUse: e => { e.source.runCommand("function toten3");
e.source.runCommand("function tirapaco3"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('tmb_pacote_tuiuiu_toten5:trigger', {
  onUse: e => { e.source.runCommand("function toten5");
e.source.runCommand("function tirapaco5"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('tmb_pacote_tuiuiu_toten4:trigger', {
  onUse: e => { e.source.runCommand("function toten4");
e.source.runCommand("function tirapaco4"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('tmb_pacote_tuiuiu_toten6:trigger', {
  onUse: e => { e.source.runCommand("function toten6");
e.source.runCommand("function tirapaco6"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('tmb_pacote_tuiuiu_toten7:trigger', {
  onUse: e => { e.source.runCommand("function toten7");
e.source.runCommand("function tirapaco7"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('tmb_pacote_tuiuiu_toten8:trigger', {
  onUse: e => { e.source.runCommand("function toten8");
e.source.runCommand("function tirapaco8"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('tmb_machado_assis:trigger', {
  
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('tmb_rede_dpesca:trigger', {
  onUse: e => { e.source.runCommand("function peixemorto"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('tmb_babatana_boto_cor_rosa:trigger', {
  onUse: e => { e.source.runCommand("function regenerationrosa"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('tmb_pente_carapato:trigger', {
  onConsume: e => {
  e.source.addEffect("minecraft:poison", 600, {amplifier: 1});
  
},

  
});

initEvent.itemComponentRegistry.registerCustomComponent('tmb_totem_dserpente:trigger', {
  onUse: e => { e.source.runCommand("function venenodetotem");
e.source.runCommand("function tirarefeitodemin"); },
});

initEvent.itemComponentRegistry.registerCustomComponent('tmb_poc_cegueira:trigger', {
  onConsume: e => {
  e.source.addEffect("minecraft:blindness", 600, {amplifier: 1});
  
},

  
});

initEvent.itemComponentRegistry.registerCustomComponent('tmb_poc_cegueira_prolongada:trigger', {
  onConsume: e => {
  e.source.addEffect("minecraft:blindness", 2000, {amplifier: 1});
  
},

  
});
 });
{initEvent.itemComponentRegistry.registerCustomComponent("tmb_zarabatana_crgd_varias:trigger", {
    onUse: e => {
        const equippable = e.source.getComponent("minecraft:equippable");
        if (!equippable) return;
        const mainhand = equippable.getEquipmentSlot("Mainhand");
        if (!mainhand.hasItem()) return;
        mainhand.amount++;
    },
})
}
{initEvent.itemComponentRegistry.registerCustomComponent("tmb_zarabatana_crgd_aparic_varias:trigger", {
    onUse: e => {
        const equippable = e.source.getComponent("minecraft:equippable");
        if (!equippable) return;
        const mainhand = equippable.getEquipmentSlot("Mainhand");
        if (!mainhand.hasItem()) return;
        mainhand.amount++;
    },
})
}
{initEvent.itemComponentRegistry.registerCustomComponent("tmb_zarabatana_crgd_dinamaite_varias:trigger", {
    onUse: e => {
        const equippable = e.source.getComponent("minecraft:equippable");
        if (!equippable) return;
        const mainhand = equippable.getEquipmentSlot("Mainhand");
        if (!mainhand.hasItem()) return;
        mainhand.amount++;
    },
})
}
